import { PointDrawer } from "../../point-component/drawers/point-drawer";
import { ELEMENTS_CLASS } from "../../../core/enums/elements-class-enum";
import { Drawer } from "../../../core/drawers/drawer";
import { app as App } from "../../../app";
import { objects } from "../../../core/application/objects";

export class IntersectionDrawer extends Drawer {
  static FIRST_OBJECT_STATE() {
    return "FIRST_OBJECT";
  }
  static SECOND_OBJECT_STATE() {
    return "SECOND_OBJECTf";
  }
  constructor() {
    super();
    this.objectA;
    this.objectB;
    this.aggregatorA;
    this.aggregatorB;
    this.label;
    this.point;
    this.states = [
      IntersectionDrawer.FIRST_OBJECT_STATE,
      IntersectionDrawer.SECOND_OBJECT_STATE
    ];
    this.intersections = [];
    this.pointDrawer = new PointDrawer();
    super.setElementClass(ELEMENTS_CLASS.INTERSECTION_POINT);
  }
  draw(e) {
    if (e == undefined || !this.isValidObject(e.target)) return;
    const selectedTool = App.getSelectedTool();
    if (
      selectedTool != undefined &&
      selectedTool.drawer != undefined &&
      selectedTool.drawer.elementClass == ELEMENTS_CLASS.INTERSECTION_POINT
    ) {
      if (
        this.state == undefined ||
        this.state == IntersectionDrawer.FIRST_OBJECT_STATE
      ) {
        this.setFirstObject(e.target);
        this.setState(IntersectionDrawer.SECOND_OBJECT_STATE);
      } else if (this.state == IntersectionDrawer.SECOND_OBJECT_STATE) {
        this.setSecondObject(e.target);
        this.drawPoint();
        this.clear();
      }
    }
  }
  setFirstObject(konvaObject) {
    const aggregator = this.getObjectAggregator(konvaObject);
    this.aggregatorA = aggregator;
  }
  setSecondObject(konvaObject) {
    const aggregator = this.getObjectAggregator(konvaObject);
    this.aggregatorB = aggregator;
  }
  getObjectAggregator(konvaObject) {
    return objects.getByKonvaObject(konvaObject)[0];
  }
  drawPoint() {
    console.info("generic object", this.aggregatorA);
    const intersectionPoint = this.aggregatorA.genericObject.getIntersection(
      this.aggregatorB.genericObject
    );
    console.info("intersection point", intersectionPoint);
    PointDrawer.drawPoint(intersectionPoint, false);
  }
  isValidObject(konvaObject) {
    return konvaObject.attrs.class == ELEMENTS_CLASS.LINE_SEGMENT;
  }
}
